Fixed default 6ch audio option. It wasn't truly the default before.
[rip_dvd/.git] / rip_dvd
diff --git a/rip_dvd b/rip_dvd
index 3696fe8b70d36bc96aa05071cc6cd1b535c8d1d9..ae6f9500d0131638c870321f27ea94f474e10354 100755 (executable)
--- a/rip_dvd
+++ b/rip_dvd
@@ -3,7 +3,7 @@
 # Author: Alan J. Pippin (apippin@pippins.net)
 # Date: 05/17/2009
 #
-  REV=2.0
+  REV=2.5
 #
 # Description: This script wraps a number of linux utilities to
 # create a recipe for ripping protected DVDs, circumventing 
 # Known Issues/Limitations:
 # - Mirror mode is always done in ISO mode
 #
-# Package Dependencies (apt-get install these for example):
-# lsdvd dvdauthor gddrescue dvdbackup tovid mencoder mplayer genisoimage libdvdcss2
-#
-# Specific Executable (program) Dependencies (must be found in $PATH):
-# volname makexml lsdvd dvdauthor gddrescue dvdbackup mencoder mplayer mkisofs HandBrakeCLI
-#
-# Optional Dependencies:
-# lookup imdb info/posters for mythvideo: http://www.mythtv.org/wiki/Fill_mythvideo_metadata.pl
-#
+# See the README file for information about the dependencies
+# this script has.
 
 ##############################################################################################
 # Global Variables
@@ -60,13 +53,21 @@ typeset -i make_final_dest_comp=0
 typeset -i errors=0
 typeset -i show_usage=0
 typeset -i mirror_mode=0
-typeset -i target_bitrate=2000
+typeset -i target_video_bitrate=2000
+typeset -i target_audio_bitrate=224
 typeset -i target_size=0
 typeset -i audio_2ch=0
-typeset -i audio_6ch=1
+typeset -i audio_6ch=0
 typeset -i invalid_feature_title=0
 typeset -i feature_title_override=0
 typeset -i mplayer_dumpstream_incompatibility=0
+typeset -i lsdvd_incompatibility=0
+typeset -i custom_video_bitrate=0
+typeset -i custom_audio_bitrate=0
+typeset -i custom_audio_2ch=0
+typeset -i custom_audio_6ch=0
+typeset -i minimum_feature_title_length=10
+typeset -i lsdvd_timeout=10
 
 ##############################################################################
 # Local Machine Settings:
@@ -102,15 +103,16 @@ fi
 ##############################################################################################
 # Command line processing
 ##############################################################################################
-while (($#)) && getopts 162wmvifkzx:ht:n:d:b:s:t:a:p:e:j:l:r: opt "$@"
+while (($#)) && getopts 162wmvifkzx:ht:n:d:b:B:s:t:a:p:e:j:l:r: opt "$@"
 do
     case $opt in
         (n)     dvdname=$OPTARG;;
         (d)     dest=$OPTARG;;
-        (b)     target_bitrate=$OPTARG;;
+        (b)     target_video_bitrate=$OPTARG; custom_video_bitrate=1;;
+        (B)     target_audio_bitrate=$OPTARG; custom_audio_bitrate=1;;
        (s)     target_size=$OPTARG;;
-        (2)     audio_2ch=1;;
-        (6)     audio_6ch=1;;
+        (2)     audio_2ch=1; custom_audio_2ch=1;;
+        (6)     audio_6ch=1; custom_audio_6ch=1;;
         (1)     force_onepass_mode=1;;
         (v)     make_final_dest_vob=1;;
         (i)     make_final_dest_iso=1;;
@@ -170,7 +172,8 @@ function usage() {
     echo >&2 "   -e <encoder>  Specify the encoder to use to make the compressed file (valid encoders=mencoder|handbrake) (default=handbrake if found)"
     echo >&2 "                 You must also specify the target size or bitrate using the '-s' or '-b' options with xvid profiles"
     echo >&2 "   -s <size>     Set the target size of the compressed file in MB (ex: 700, 1000, etc)"
-    echo >&2 "   -b <bitrate>  Set the bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
+    echo >&2 "   -b <bitrate>  Set the video bitrate desired in the compressed file in kbits/sec (ex: 1500, 2000 (default), etc)"    
+    echo >&2 "   -B <bitrate>  Set the audio bitrate desired in the compressed file in kbits/sec (ex: 96, 128, 160, 224 (default), 300, etc)"    
     echo >&2 "   -a <W:H>      Specify the width x height aspect ratio to scale the DVD to (only used in -z mode)"
     echo >&2 "      <W>        If only the width is given, it will autoset the height to a value which preserves the aspect ratio"
     echo >&2 "                 The default behavior is autoaspect mode, which preserves the original aspect, with no scaling being done"
@@ -216,7 +219,7 @@ if ([ $target_size -ne 0 ] || [ "$aspect" != "" ]) && [ $make_final_dest_comp -n
   usage
 fi
 
-if [ $target_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
+if [ $target_video_bitrate -eq 0 ] && [ $target_size -eq 0 ] && [ $make_final_dest_comp -eq 1 ]; then
   echo "-E- You must specify a bitrate in compressed file mode. You must specify '-b' or '-s' when using '-z'" | tee -a $logfile
   usage
 fi
@@ -229,6 +232,12 @@ if [ $mirror_mode -eq 1 ]; then
   fi
 fi
 
+# If audio channel requirements weren't given, assume a default value of 6channel audio
+if [ $audio_2ch -eq 0 ] && [ $audio_6ch -eq 0 ]; then
+  audio_6ch=1
+  custom_audio_6ch=1
+fi
+
 # Make handbrake the default encoder if not specified and we can find it
 if [ -z "$encoder" ]; then
   encoder="mencoder"; # If we can't find handbrake, set mencoder as the default
@@ -278,6 +287,8 @@ fi
 [[ ! -x `which makexml` ]] && echo "-E- missing dependency: makexml" && exit
 [[ ! -x `which dvdauthor` ]] && echo "-E- missing dependency: dvdauthor" && exit
 [[ ! -x `which mkisofs` ]] && echo "-E- missing dependency: mkisofs" && exit
+[[ -n "$handbrake_xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing handbrake xvid encoder, set in rip_dvd.conf to: $handbrake_xvid" && exit
+[[ -n "$handbrake_mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing handbrake mp4 encoder, set in rip_dvd.conf to: $handbrake_mp4" && exit
 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "xvid" ]] && [[ ! -x `which $handbrake_xvid` ]] && echo "-E- missing encoder: $handbrake_xvid" && exit
 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "mp4" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
 [[ "$encoder" == "handbrake" ]] && [[ "$profile" =~ "ip" ]] && [[ ! -x `which $handbrake_mp4` ]] && echo "-E- missing encoder: $handbrake_mp4" && exit
@@ -463,6 +474,55 @@ trap cleanup EXIT
 # processing functions
 ##############################################################################################
 
+function alarm() { perl -e 'alarm shift; exec @ARGV' "$@"; }
+
+function lsdvd_longest_title {
+  dev="$1"
+
+  # Only use lsdvd to extract the longest feature title if we didn't detect an incompatibility earlier
+  if [ $lsdvd_incompatibility -eq 1 ]; then
+    invalid_feature_title=1
+    return
+  fi
+
+  # Try the normal lsdvd command to see if it works
+  alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
+  if [ $? != 0 ]; then
+    # lsdvd didn't work
+    invalid_feature_title=1
+    lsdvd_incompatibility=1
+    return
+  fi
+  # lsdvd is good to go, use it
+  feature_title=`lsdvd $dev 2>/dev/null | awk '/Longest/ { print $NF }'`
+}
+
+function lsdvd_css {
+  dev="$1"
+
+  # Try the normal lsdvd command to see if it works
+  alarm $lsdvd_timeout lsdvd $dev >> "$logfile" 2>&1
+
+  if [ $? != 0 ]; then
+    # lsdvd didn't work. Try VLC.
+    lsdvd_incompatibility=1
+    if [[ -x `which cvlc` ]]; then 
+      echo "-> lsdvd failed to DeCSS the DVD. Trying VLC: $dev" | tee -a "$logfile"
+      alarm $lsdvd_timeout cvlc --no-video --no-audio $dev  >> "$logfile" 2>&1
+      # Once you get a DVD that VLC can't handle, figure out how 
+      # to detect that here and abort.
+      #if [ $? != 1 ]; then
+      #  echo "-> VLC failed to decss the DVD."
+      #  return 1
+      #fi
+    else
+      fatal_and_exit "-E- lsdvd failed to DeCSS the DVD. VLC not found, but required to rip this DVD."
+    fi
+  fi
+  return 0
+}
+
 # encode the vob file into a compressed file format using handbrake
 function encode_vob_file_handbrake {
   
@@ -472,6 +532,8 @@ function encode_vob_file_handbrake {
   typeset filetype=""
   typeset handbrake_audio_opts=""
   typeset hb_profile=""
+  typeset SIZE=""
+  typeset AUDIO_BITRATE=""
 
   # Set a variable that we will use later to determine if we found a handler for $profile or not
   typeset -i found_profile=0    
@@ -484,8 +546,14 @@ function encode_vob_file_handbrake {
   # Set our DRC option
   DRC="-D $drc"
 
-  # Check the global force_onepass_mode. If it is set, change our variables appropriately
-  # to force 1-pass encoding across all profiles.
+  if [ $target_size -ne 0 ]; then
+    SIZE="-S $target_size"
+  fi 
+
+  if [ $custom_audio_bitrate -eq 1 ]; then
+    AUDIO_BITRATE="-B $target_audio_bitrate"
+  fi
+
   if [ $force_onepass_mode -eq 1 ]; then
     PASSES=""
   fi
@@ -503,7 +571,7 @@ function encode_vob_file_handbrake {
     # Very High Quality (16fps)
     if [ "$profile" == "xvidvhq" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[1]="-b $target_video_bitrate"
       handbrake_opts[2]="-e xvid"
       handbrake_opts[3]="-T"
       handbrake_opts[4]="-5"
@@ -512,7 +580,7 @@ function encode_vob_file_handbrake {
     # High Quality (20fps)
     if [ "$profile" == "xvidhq" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[1]="-b $target_video_bitrate"
       handbrake_opts[2]="-e ffmpeg"
       handbrake_opts[3]="-T"
       handbrake_opts[4]="-5"
@@ -520,7 +588,7 @@ function encode_vob_file_handbrake {
     # Fast (28fps)
     if [ "$profile" == "xvid" ]; then
       handbrake_opts[0]="-f avi"
-      handbrake_opts[1]="-b $target_bitrate"
+      handbrake_opts[1]="-b $target_video_bitrate"
       handbrake_opts[2]="-e ffmpeg"
       handbrake_opts[3]="-T"
     fi
@@ -533,6 +601,17 @@ function encode_vob_file_handbrake {
     final_output_file="$dest/$dvdname.mp4"
     PASSES=""
 
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
+
     # Very High Quality
     if [ "$profile" == "mp4vhq" ]; then
       profile="hb_High_Profile"
@@ -554,18 +633,26 @@ function encode_vob_file_handbrake {
     final_output_file="$dest/$dvdname.mp4"
     PASSES=""
 
-    # Do not override the audio settings for these profiles
-    audio_2ch=0
-    audio_6ch=0
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
 
     # iphone
     if [ "$profile" == "iphone" ]; then
-      profile="hb_iPhone"
+      profile="hb_iPhone_&_iPod_Touch"
     fi
     # ipod
     if [ "$profile" == "ipod" ]; then
       profile="hb_iPod"
     fi
+
   fi
   
   # Predefined Handbrake Profile Handling
@@ -574,6 +661,17 @@ function encode_vob_file_handbrake {
     handbrake_cli="$handbrake_mp4"
     final_output_file="$dest/$dvdname.mp4"
     PASSES=""
+
+    # Handle custom parameter overrides
+    if [ $custom_video_bitrate == 1 ]; then
+      handbrake_opts[0]="-b $target_video_bitrate"
+    fi
+    if [ $custom_audio_2ch == 0 ]; then
+      audio_2ch=0
+    fi
+    if [ $custom_audio_6ch == 0 ]; then
+      audio_6ch=0
+    fi
     
     # extract the HandBrake Profile name from $profile
     hb_profile=`echo "$profile" | sed 's/hb_//g' | sed 's/_/ /g'`
@@ -614,8 +712,12 @@ function encode_vob_file_handbrake {
   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $PASSES"
   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $DRC"
   handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SCALE"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $SIZE"
+  handbrake_cmd_line_opts="$handbrake_cmd_line_opts $AUDIO_BITRATE"
 
   # Execute the handbrake command to encode the video
+  # I have to copy-n-paste the code below to handle the 2 conditions, 1) hb_profile (mp4) 2) no hb_profile (xvid)
+  # The problem is the -Z "$hb_profile" option. I have to quote the "$hb_profile" due to spaces in it, forcing me to call it out explicity.
   if [ -n "$hb_profile" ]; then
     echo -e "\n   Encoding: $handbrake_cli -i \"$vobfile\" -o \"$final_output_file\" -Z \"$hb_profile\" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1" >> "$logfile"
     $handbrake_cli -i "$vobfile" -o "$final_output_file" -Z "$hb_profile" $handbrake_cmd_line_opts $handbrake_audio_opts $handbrake_video_encoder_opts >> $encodelog 2>&1
@@ -669,7 +771,7 @@ function encode_vob_file_mencoder {
 
     # Very High Quality (16fps)
     if [ "$profile" == "xvidvhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="chroma_opt"
       video_encoder_opts[3]="vhq=4"
@@ -679,7 +781,7 @@ function encode_vob_file_mencoder {
     fi
     # High Quality (20fps)
     if [ "$profile" == "xvidhq" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="chroma_opt"
       video_encoder_opts[3]="vhq=2"
@@ -689,7 +791,7 @@ function encode_vob_file_mencoder {
     fi
     # Fast (28fps)
     if [ "$profile" == "xvid" ]; then
-      video_encoder_opts[0]="bitrate=$target_bitrate"
+      video_encoder_opts[0]="bitrate=$target_video_bitrate"
       video_encoder_opts[1]="threads=$mencoder_threads"
       video_encoder_opts[2]="vhq=0"
       video_encoder_opts[3]="turbo"
@@ -709,7 +811,7 @@ function encode_vob_file_mencoder {
       mencoder_audioch_opts[2]=""
     else
       # These options produce good 2 channel audio for linux and windows (including the internal mythvideo player)
-      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$audio_bitrate"
+      mencoder_audio_opts="-oac mp3lame -lameopts cbr:br=$target_audio_bitrate"
       mencoder_audioch_opts[0]=""
     fi
  
@@ -736,7 +838,7 @@ function encode_vob_file_mencoder {
     mencoder_output_opts="-ofps 30000/1001 -sws 9 -of lavf -lavfopts format=mp4"
     mencoder_video_filter_opts="-vf harddup$CROP$SCALE";
     mencoder_video_encoder_opts="-ovc x264 -x264encopts $pass_opt"
-    video_encoder_opts[0]="bitrate=$target_bitrate"
+    video_encoder_opts[0]="bitrate=$target_video_bitrate"
     video_encoder_opts[1]="threads=$mencoder_threads"
     video_encoder_opts[2]="vbv_maxrate=1500"
     video_encoder_opts[3]="vbv_bufsize=2000"
@@ -753,7 +855,7 @@ function encode_vob_file_mencoder {
       mencoder_video_encoder_opts="$mencoder_video_encoder_opts:$OPTS"
     done
 
-    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$audio_bitrate:raw"
+    mencoder_audio_opts="-oac faac -faacopts mpeg=4:object=2:br=$target_audio_bitrate:raw"
     mencoder_audioch_opts[0]="-channels 2 -srate 48000"
   fi
 
@@ -805,7 +907,7 @@ function make_dvd_iso_image {
   # check to see if we have a dvdpath to rip from instead of $dev
   if [ -z "$dvdpath" ]; then
     # load the CSS codes in the DVD drive 
-    lsdvd $dev >> "$logfile"
+    lsdvd_css "$dev"
     if [ $? != 0 ]; then
       fatal_and_exit "-E- lsdvd $dev failed" 
     fi
@@ -906,9 +1008,9 @@ function get_feature_title {
   fi
   # otherwise, use lsdvd to figure it out
   if [ $ripdvd -eq 1 ]; then
-    feature_title=`lsdvd $dev | awk '/Longest/ { print $NF }'`
+    lsdvd_longest_title "$dev" 
   else 
-    feature_title=`lsdvd "$source" 2>/dev/null | awk '/Longest/ { print $NF }'`
+    lsdvd_longest_title "$source"
   fi
 }
 
@@ -941,7 +1043,7 @@ function create_main_vob_with_mplayer {
   # check to make sure we didn't detect an mplayer dumpstream incompatibility earlier
   if [ $mplayer_dumpstream_incompatibility -eq 1 ]; then
     msg="-E- We detected an mplayer dumpstream incompatibility earlier."
-    msg="$msg We also detected another condition that requires us to use dumpstream. "
+    msg="$msg We also detected a condition that may require you to use dumpstream. "
     msg="$msg\n    Unable to rip this DVD in the mode you requested."
     fatal_and_exit "$msg"
   fi
@@ -1057,18 +1159,19 @@ function get_audio_track_from_vob {
   
   # extract the audio streams in the vob
   #ffmpeg -i "$vob" > $aidcheck 2>&1
-  $handbrake_cli --stop-at 0 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
+  $handbrake_cli --stop-at duration:1 -i "$vob" -o /dev/null -v 100 > $aidcheck 2>&1
   
   # find the stream that matches our aid
   #stream=`grep "Stream.*\[0x$aid_hex\]" $aidcheck`
-  stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
+  #stream=`grep "scan: audio" $aidcheck | grep -n "" | grep "scan: audio 0x$aid_hex"`
+  stream=`grep "add_audio_to_title:" $aidcheck | grep -n "" | grep "add_audio_to_title:.* stream 0x$aid_hex"`
  
   # extract the track number that handbrake uses
   #track=`expr match "$stream" '.*#[0-9]\.\([0-9]*\)'`
   track=`expr match "$stream" '^\([0-9]*\):'`
 
   if [ -n "$track" ]; then   
-    echo "-> Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
+    echo "   Setting the audio ID to $aid. Setting the audio track to $track." | tee -a "$logfile"
   fi
 }
 
@@ -1202,10 +1305,23 @@ function check_vob_for_a52_crc_errors {
 
 function calculate_bitrate_from_target_size {
   # determine what our bitrate needs to be if a target size was specified instead
-  if [ $target_size -ne 0 ]; then
+  if [ $target_size -ne 0 ] && [ $custom_video_bitrate -eq 0 ]; then
     vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
-    ((target_bitrate = (target_size * 1024 * 8) / vob_length ))
-    echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_bitrate kbits/sec"
+    ((min_length = minimum_feature_title_length * 60))
+    if [[ $vob_length -gt $min_length ]]; then 
+      ((target_video_bitrate = (target_size * 1024 * 8) / vob_length ))
+      custom_video_bitrate=1
+      echo "   With a given target size of $target_size MB, the estimated bit rate will need to be $target_video_bitrate kbits/sec" | tee -a "$logfile"
+    else
+      echo "-W- Unable to determine the real length of this DVD feature title." | tee -a "$logfile"
+      echo "    A target bitrate from the target_size requested will not be set." | tee -a "$logfile"
+      echo "    If using handbrake, only the target_size will be passed to the encoder." | tee -a "$logfile" 
+      echo "    If using mencoder, the target_size will be entirely disregarded." | tee -a "$logfile"
+      echo "    You may need to rerun with the -b option with a target bitrate to get the desired size." | tee -a "$logfile"
+      if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
+        fatal_and_exit "-E- You'll need rip this DVD with the handbrake encoder and an MP4 type profile to get a good rip."
+      fi
+    fi
   fi
 }
 
@@ -1263,6 +1379,15 @@ function check_for_mplayer_dumpstream_incompatibility {
 
   echo "-> Checking for mplayer dumpstream incompatibilities" | tee -a "$logfile"
 
+  # Check to see if the DVD had any lsdvd incompatibilities
+  if [ $lsdvd_incompatibility -eq 1 ]; then
+    invalid_feature_title=1
+    echo "-E- Unable to determine the feature title due to an lsdvd inability to DeCSS" | tee -a "$logfile"
+    echo "    You will need to determine this yourself and rerun the script with the -t option" | tee -a "$logfile"
+    echo "    You can google this DVD to find out what it's feature title is, or you can play it in a conventional DVD player to find it." | tee -a "$logfile"    
+    return
+  fi
+
   if [ ! -e "$vobfile" ]; then
     # mplayer dumpstream does not work on DVDs that obscure the feature title.
     # A DVD that has 99 titles, where the longest title isn't the main feature
@@ -1270,9 +1395,9 @@ function check_for_mplayer_dumpstream_incompatibility {
     # out what the feature title is. This script will run through that flow if we
     # set use_mplayer_dumpstream to 0. Check for this here.
     if [ $ripdvd -eq 1 ]; then
-      lsdvd $dev | grep -q "Title: 99"
+      alarm $lsdvd_timeout lsdvd $dev | grep -q "Title: 99"
     else
-      lsdvd "$isofile" | grep -q "Title: 99"
+      alarm $lsdvd_timeout lsdvd "$isofile" | grep -q "Title: 99"
     fi
     # If we have 99 titles and a feature title wasn't given on the command line, switch modes.
     if [ $? == 0 ] && [ $feature_title_override -eq 0 ]; then
@@ -1307,6 +1432,23 @@ function check_for_mplayer_dumpstream_incompatibility {
     fi
     [[ -e "$dumplog" ]] && rm -f $dumplog
   fi
+
+  # There is another form of protection that causes the mplayer dumpstream to fail.
+  # The resulting VOB file looks complete, but has something in it that causes mplayer/mencoder 
+  # to be unable to encode it since it thinks the entire VOB is only a few minutes long in length.
+  # Using HandBrake with an MP4 type profile can work around this, but mencoder or Handbrake with XVID profile won't.
+  if [ -e "$vobfile" ]; then
+    vob_length=`mplayer -identify -v "$vobfile" -endpos 0 2>&1 | grep ID_LENGTH | awk -F '=' '{ print $2 }' | awk -F '.' '{ print $1 }'`
+    ((min_length = minimum_feature_title_length * 60))
+    if [[ $vob_length -lt $min_length ]]; then 
+      if [[ $encoder -ne "handbrake" ]] || [[ "$profile" =~ "xvid" ]]; then
+        echo "-E- The main feature title that was ripped from the DVD has an invalid movie length." | tee -a "$logfile"
+        echo "    You'll need rip this DVD with the handbrake encoder and an MP4 type profile instead." | tee -a "$logfile"
+        mplayer_dumpstream_incompatibility=1
+       fatal_and_exit "-E- Aborting encoding step due to invalid movie length."
+      fi
+    fi
+  fi
 }
 
 function fill_mythvideo_metadata {